/*
 * Copyright (c) 2006, Adam Dunkels
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the author nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include <stdio.h>
#include "tokenizer.h"
#include "ubasic.h"

static const char program[] =
"\
10 z=1\n\
15 gosub 100\n\
20 for i = 1 to half 20\n\
30 adc [i - 1] = 40\n\
32 d = adc [i - 1]\n\
33 lcdout 30, d*5, \"test\"\n\
35 print d, systick, half systick, half z,  \"tescht\", z\n\
37 half 45\n\
40 next i\n\
50 print \"end\"\n\
60 end\n\
100 print \"subroutine\"\n\
110 return\n";



int systick = 12287;

int adc [8] = { 1, 2, 3, 4, 5, 6, 7, 8, };



int lcdoutfunc (T_USER_FUNC_DATAS stDatas)
{
	printf ("lcd write %d %d %s\n\r", stDatas [0].value, stDatas [1].value, stDatas [2].text);
	return 0;
}


int halffunc (T_USER_FUNC_DATAS stDatas)
{
	if (stDatas [0].type != 1) { FATAL_ABORT (); }
	return stDatas [0].value / 2;
}

int dblfunc (T_USER_FUNC_DATAS stDatas)
{
	if (stDatas [0].type != 1) { FATAL_ABORT (); }
	return stDatas [0].value * 2;
}

int resetfunc (T_USER_FUNC_DATAS stDatas)
{
	return 0;
}


/*---------------------------------------------------------------------------*/
int
main(void)
{
  ubasic_init(program);

  do {
    ubasic_run();
  } while(!ubasic_finished());

  return 0;
}
/*---------------------------------------------------------------------------*/
